package com.sky.ioc.service.assets.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.Cake;
import com.sky.ioc.entity.params.IocParam;
import com.sky.ioc.service.assets.AssetService;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

/**
 * TODO
 * @Description 资产
 * @Author LunCe
 * @Date 2023/2/23 17:04
 **/

@Service
public class AssetServiceImpl implements AssetService {
    @Override
    public ReturnMsg getInvestmentDistribution() {
        String[] param = {"investment1","investment2","investment3","investment4","rateReturn"};
        String[] labKey = {"1季度","2季度","3季度","4季度"};
        ThreadLocalRandom random = ThreadLocalRandom.current();
        //List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        List<Label> list = new ArrayList<>();
        for (int i = 0; i < labKey.length; i++) {
            Label label = new Label();
            JSONObject jsonObject = new JSONObject();
            int i1 = random.nextInt(50, 150);
            int i2 = random.nextInt(50, 150);
            int i3 = random.nextInt(50, 150);
            int i4 = random.nextInt(50, 150);
            int i5 = random.nextInt(10, 100);
            jsonObject.put(param[0],i1);
            jsonObject.put(param[1],i2);
            jsonObject.put(param[2],i3);
            jsonObject.put(param[3],i4);
            jsonObject.put(param[4],i5);
            label.setJsonObject(jsonObject);
            label.setLabel(labKey[i]);
            list.add(label);
        }
        return ReturnMsg.ok(list);
    }

    @Override
    public ReturnMsg getAssetLife() {
        String[] param = {"serviceLife","standardLife"};
        String[] labKey = {"资产1","资产2","资产3","资产4","资产5","资产6"};
        ThreadLocalRandom random = ThreadLocalRandom.current();
        List<Label> list = new ArrayList<>();
        for (int i = 0; i < labKey.length; i++) {
            Label label = new Label();
            JSONObject jsonObject = new JSONObject();
            int i2 = random.nextInt(2, 40);
            int i1 = random.nextInt(2, i2);
            jsonObject.put(param[0],i1);
            jsonObject.put(param[1],i2);
            label.setJsonObject(jsonObject);
            label.setLabel(labKey[i]);
            list.add(label);
        }
      //  List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(list);
    }

    @Override
    public ReturnMsg getAssetCount() {
        Map<String, Object> map = new HashMap<>();
        map.put("yearCount","12000");
        map.put("yearCountYoy","0.4%");
        map.put("totalAssetCount","2100");
        map.put("totalAssetCountYoy","0.2%");
        map.put("totalAssetsPerSapita","15");
        map.put("averageServiceLifeOfAssets","10");
        map.put("worthAttention","内容");
        return  ReturnMsg.ok(map);
    }

    @Override
    public ReturnMsg getOperAssetCoreIndicators(IocParam iocParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        ThreadLocalRandom random = ThreadLocalRandom.current();
        DecimalFormat decimalFormat = new DecimalFormat("#.0");
        double totalAsset = random.nextDouble(1,10);
        totalAsset = Double.parseDouble(decimalFormat.format(totalAsset));
        int assetCount = random.nextInt(100, 1000);
        float compare = (float) Math.random();
        compare = Float.parseFloat(decimalFormat.format(compare));

        objects.get(0).put("value",totalAsset);
        objects.get(0).put("compare",compare);

        objects.get(1).put("value",assetCount);
        objects.get(1).put("compare",compare);

        objects.get(2).put("value","项目1");
        objects.get(2).put("compare",60);

        objects.get(3).put("value","工业互联网");
        objects.get(3).put("compare",60);
        indeicator.setWorthAttention("13笔记本即将到报废年限");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAssetAnalysis(IocParam iocParam) {
        String[] param = {"investment1","investment2","investment3","investment4","rateReturn"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getAssetShareRanking(IocParam iocParam) {
        List<Cake> list = new ArrayList<>();
        list.add(new Cake("资产1"));
        list.add(new Cake("资产2"));
        list.add(new Cake("资产3"));
        list.add(new Cake("资产4"));
        list.add(new Cake("资产5"));
        list.add(new Cake("资产6"));
        return ReturnMsg.ok(list);
    }

    @Override
    public ReturnMsg getScrapAndMaintain(IocParam iocParam) {
        List<Cake> list = new ArrayList<>();
        list.add(new Cake("其他部门"));
        list.add(new Cake("管理部门"));
        list.add(new Cake("销售部门"));
        return ReturnMsg.ok(list);
    }

    @Override
    public ReturnMsg getAssetCoreIndicators() {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        ThreadLocalRandom random = ThreadLocalRandom.current();
        int yearAsset = random.nextInt(8000, 10000);//年度
        int  personAsset= random.nextInt(50,100);//人均
        int totalyear = random.nextInt(2,8);
        int totalAsset = random.nextInt(150000, 300000);
        float compare = (float) Math.random();
        DecimalFormat decimalFormat = new DecimalFormat("#.0");
        compare = Float.parseFloat(decimalFormat.format(compare));

        objects.get(0).put("value",yearAsset);
        objects.get(0).put("compare",compare);

        objects.get(1).put("value",totalAsset);
        objects.get(1).put("compare",compare);

        objects.get(2).put("value",personAsset);
        objects.get(2).put("compare",compare);

        objects.get(3).put("value",totalyear);
        indeicator.setWorthAttention("内容");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAssetAge(IocParam iocParam) {
        String[] param = {"assetsName","rateReturn"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }
}
